#!/bin/sh
#
#   check.sh -- check that things look right for a build
#
#   Copyright 1996 Arizona Board of Regents; see COPYRIGHT file for details.

if [ ! -d jdk/. ]; then
    echo ""
    echo "    The JDK was not found.  You must make a symlink from ./jdk"
    echo "    to the JDK (which typically unpacks as "java").  For example:"
    echo "        ln -s /usr/local/java jdk"
    echo ""
    exit 1
fi

if [ ! -r jdk/lib/classes.zip -o  \
     ! -x jdk/bin/javac -o \
     ! -x jdk/bin/java ] ; then
    echo ""
    echo "    The JDK does not look quite right.  Could not find one of:"
    echo "        jdk/lib/classes.zip"
    echo "        jdk/bin/javac"
    echo "        jdk/bin/java"
    echo ""
    exit 1
fi

exit 0
