/* Copyright 1996 Arizona Board of Regents; see COPYRIGHT file for details. */

#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>

#include "toba.h"
#include "java_lang_ProcessReaper.h"
#include "java_lang_UNIXProcess.h"

/* java/lang/ProcessReaper waitForDeath ()V */
Void waitForDeath__jgUPj(Object Harg1)
/*ARGSUSED*/
{
    pid_t pid;
    int status;

    /* 
     * this daemon process continually loops
     * waiting for children to die
     */
    for(;;) {
        if((pid = waitpid(-1, &status, 0)) == -1) {
            if(errno == EINTR)
                continue;
            else
                break;
        }
        if(WIFEXITED(status)) {
            /* UNIXProcess.deadChild(int,int) */
            deadChild_ii_s5Vsh(pid, WEXITSTATUS(status));
        }
        if(WIFSIGNALED(status)) {
            /* UNIXProcess.deadChild(int,int) */
            deadChild_ii_s5Vsh(pid, -1);
        }
    }
}

