/* Copyright 1996 Arizona Board of Regents; see COPYRIGHT file for details. */

#include "toba.h"
#include "runtime.h"
#include "../gc/gc.h"
#include "java_lang_Runtime.h"
#include "java_lang_UNIXProcess.h"

#include <sys/time.h>
#include <sys/resource.h>



/* java/lang/Runtime exitInternal (I)V */
Void exitInternal_i_zIKEN(Object Harg1, Int arg2)
/*ARGSUSED*/
{
    terminate(arg2);
}

/* java/lang/Runtime execInternal ([Ljava/lang/String;[Ljava/lang/String;)Ljava/lang/Process; */
Object execInternal_aSaS_pYOyC(Object Harg1, Object Harg2, Object Harg3)
{
    struct in_java_lang_Runtime *this = (struct in_java_lang_Runtime *)Harg1;
    struct in_java_lang_UNIXProcess *process;

    /* create a java.lang.UNIXProcess and return it */
    process = (struct in_java_lang_UNIXProcess *)
                 new(&cl_java_lang_UNIXProcess.C);

    /* Harg3 can be null but Harg2 cannot */
    if(! Harg2)
        throwNullPointerException(0);

    /* UNIXProcess.init(String[],String[]) */
    init_aSaS_ag12q(process, Harg2, Harg3);

    return process;
}

/* java/lang/Runtime freeMemory ()J */
Long freeMemory__Ivacq(Object Harg1)
/*ARGSUSED*/
{
    struct rlimit lims;
    int heapsize = GC_get_heap_size();

    getrlimit(RLIMIT_DATA, &lims);
    return lims.rlim_cur - heapsize;
}

/* java/lang/Runtime totalMemory ()J */
Long totalMemory__8OtkB(Object Harg1)
/*ARGSUSED*/
{
    struct rlimit lims;

    getrlimit(RLIMIT_DATA, &lims);
    return lims.rlim_cur;
}

/* java/lang/Runtime gc ()V */
Void gc__tAMwu(Object Harg1)
/*ARGSUSED*/
{
    GC_gcollect();
}

/* java/lang/Runtime runFinalization ()V */
Void runFinalization__WV7ck(Object Harg1)
/*ARGSUSED*/
{
    run_some_finalizers(0);
}

/* java/lang/Runtime traceInstructions (Z)V */
Void traceInstructions_z_x0Ew4(Object Harg1, Boolean arg2)
/*ARGSUSED*/
{
    /* 
     * "the virtual machine may ignore this request if it does not support
     * this feature"  -java api vol I, pg 82
     */
}

/* java/lang/Runtime traceMethodCalls (Z)V */
Void traceMethodCalls_z_aBRgg(Object Harg1, Boolean arg2)
/*ARGSUSED*/
{
    /* 
     * "the virtual machine may ignore this request if it does not support
     * this feature"  -java api vol I, pg 82
     */
}

/* synchronized java/lang/Runtime initializeLinkerInternal ()Ljava/lang/String; */
Object sy_initializeLinkerInternal__tobNT(Object Harg1)
/*ARGSUSED*/
{
    /* dynamic loading of natives not supported */
    return javastring("");
}

/* java/lang/Runtime buildLibName (Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String; */
Object buildLibName_SS_lOXXd(Object Harg1, Object Harg2, Object Harg3)
/*ARGSUSED*/
{
    /* 
     * we don't support dynamic loading of natives so the value
     * returned doesn't really matter
     */
    return Harg3;
}

/* java/lang/Runtime loadFileInternal (Ljava/lang/String;)Z */
Boolean loadFileInternal_S_K1q7k(Object Harg1, Object Harg2)
/*ARGSUSED*/
{
    /* all necessary libs are linked in statically - this is a null op */
    /* pretend that any load operation succeeded */
    return JAVA_TRUE;
}

