//  Attribute.java -- Attribute handling

//  Copyright 1996 Arizona Board of Regents; see COPYRIGHT file for details.



package toba;

import java.io.*;



class Attribute {		// field, method, or class attribute

    String name;
    byte[] data;



//  constructor loads attribute from class file

Attribute(DataInputStream d, ClassInfo c) throws IOException
{
    name = (String)c.constants[d.readUnsignedShort()].value;
    d.readFully(data = new byte[d.readInt()]);
}



//  find(a, s) -- find an attribute in an array

static byte[] find(Attribute a[], String s)
{
    for (int i = 0; i < a.length; i++)
       if (a[i].name.equals(s))
	    return a[i].data;
    return null;
}



} // class Attribute
