//  Field.java -- Methods and Variables

//  Copyright 1996 Arizona Board of Regents; see COPYRIGHT file for details.



package toba;

import java.io.*;



public class Field {		// field or method data

    public String name;		// declared name
    public String cname;	// name used in C
    public String signature;	// signature
    public int access;		// access flags
    int overrides;		// if >0, overrides ancestor this many levels up
    int mtslot;			// slot in method table; -1 if static
    Attribute attributes[];	// attributes
    Field next;			// link to other methods with same name


// constructor loads field or method from class file

Field(DataInputStream d, ClassInfo c) throws IOException
{
    access = d.readUnsignedShort();
    mtslot = -1;
    name = (String)c.constants[d.readUnsignedShort()].value;
    signature = (String)c.constants[d.readUnsignedShort()].value;
    attributes = new Attribute[d.readUnsignedShort()];
    for (int i = 0; i < attributes.length; i++)
	attributes[i] = new Attribute(d, c);
}



} // class Field
